import { mapStateToControlProps, rankWith } from '@jsonforms/core';
import { html } from '@microsoft/fast-element';
import { isOneOfNumber } from '../testers/isOneOfNumber';
import { NUMBER_CONTROL_RANK } from './RenderersRanks';
export const FilterNumberControlRendererTemplate = html `
  <template>
    <control-wrapper :control=${(x) => x.control} ?submitted=${(x) => x.submitted}>
      <zero-text-field
        :value=${(x) => { var _a; return (((_a = x.control.data) === null || _a === void 0 ? void 0 : _a.min) === undefined ? '' : x.control.data.min); }}
        @change=${(x, c) => {
    var _a, _b;
    const value = parseFloat(c.event.target.value);
    return x.control.handleChange(x.control.path, !isNaN(value)
        ? {
            min: value,
            max: ((_a = x.control.data) === null || _a === void 0 ? void 0 : _a.max) < value ? undefined : (_b = x.control.data) === null || _b === void 0 ? void 0 : _b.max,
            type: 'number',
        }
        : Object.assign(Object.assign({}, x.control.data), { min: undefined }));
}}
        placeholder="Min"
        id=${(x) => `min-${x.control.path}`}
        data-test-id=${(x) => `min-${x.control.path}`}
        @blur=${(x) => x.onBlur()}
        style="width: 100%"
      ></zero-text-field>
      <span
        style="
        font-size: xx-large; 
        color: rgb(135, 155, 166);"
      >
        -
      </span>
      <zero-text-field
        :value=${(x) => { var _a; return (((_a = x.control.data) === null || _a === void 0 ? void 0 : _a.max) === undefined ? '' : x.control.data.max); }}
        @change=${(x, c) => {
    var _a, _b;
    const value = parseFloat(c.event.target.value);
    return x.control.handleChange(x.control.path, !isNaN(value)
        ? {
            min: ((_a = x.control.data) === null || _a === void 0 ? void 0 : _a.min) > value ? undefined : (_b = x.control.data) === null || _b === void 0 ? void 0 : _b.min,
            max: value,
            type: 'number',
        }
        : Object.assign(Object.assign({}, x.control.data), { max: undefined }));
}}
        placeholder="Max"
        id=${(x) => `max-${x.control.path}`}
        data-test-id=${(x) => `max-${x.control.path}`}
        @blur=${(x) => x.onBlur()}
        style="width: 100%"
      ></zero-text-field>
    </control-wrapper>
  </template>
`;
export const FilterNumberControlRendererEntry = {
    renderer: FilterNumberControlRendererTemplate,
    tester: rankWith(NUMBER_CONTROL_RANK, isOneOfNumber),
    mapper: mapStateToControlProps,
};
